# coding: utf-8

"""
    Dyspatch API

    # Introduction  The Dyspatch API is based on the REST paradigm and features resource based URLs with standard HTTP response codes to indicate errors. We use standard HTTP authentication and request verbs and all responses are JSON formatted. See our [Implementation Guide](https://docs.dyspatch.io/development/implementing_dyspatch/) for more details on how to implement Dyspatch.  ## API Client Libraries  Dyspatch provides API Clients for the following languages and web frameworks:  - [Java](https://github.com/getdyspatch/dyspatch-java) - [Javascript](https://github.com/getdyspatch/dyspatch-javascript) - [Python](https://github.com/getdyspatch/dyspatch-python) - [C#](https://github.com/getdyspatch/dyspatch-dotnet) - [Go](https://github.com/getdyspatch/dyspatch-golang) - [Ruby](https://github.com/getdyspatch/dyspatch-ruby)   # noqa: E501

    OpenAPI spec version: 2019.10
    Contact: support@dyspatch.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from dyspatch_client.api_client import ApiClient


class LocalizationsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def localizations_localization_id_get(self, localization_id, target_language, **kwargs):  # noqa: E501
        """Get Localization Object by ID  # noqa: E501

        Returns a specific localization object with a matching ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.localizations_localization_id_get(localization_id, target_language, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str localization_id: A localization ID (required)
        :param str target_language: The type of templating language to compile as. Should only be used for visual templates. (required)
        :return: LocalizationRead
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.localizations_localization_id_get_with_http_info(localization_id, target_language, **kwargs)  # noqa: E501
        else:
            (data) = self.localizations_localization_id_get_with_http_info(localization_id, target_language, **kwargs)  # noqa: E501
            return data

    def localizations_localization_id_get_with_http_info(self, localization_id, target_language, **kwargs):  # noqa: E501
        """Get Localization Object by ID  # noqa: E501

        Returns a specific localization object with a matching ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.localizations_localization_id_get_with_http_info(localization_id, target_language, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str localization_id: A localization ID (required)
        :param str target_language: The type of templating language to compile as. Should only be used for visual templates. (required)
        :return: LocalizationRead
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['localization_id', 'target_language']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method localizations_localization_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'localization_id' is set
        if ('localization_id' not in params or
                params['localization_id'] is None):
            raise ValueError("Missing the required parameter `localization_id` when calling `localizations_localization_id_get`")  # noqa: E501
        # verify the required parameter 'target_language' is set
        if ('target_language' not in params or
                params['target_language'] is None):
            raise ValueError("Missing the required parameter `target_language` when calling `localizations_localization_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'localization_id' in params:
            path_params['localizationId'] = params['localization_id']  # noqa: E501

        query_params = []
        if 'target_language' in params:
            query_params.append(('targetLanguage', params['target_language']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/vnd.dyspatch.2019.10+json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/localizations/{localizationId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='LocalizationRead',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
